# Advanced Namespace Tools blog 

### 21 December 2019 - ANTS 5.64 .iso release

## Hypercubic Time Warp All-go-rhythmic Synchrony

Version 5.64 of the Advanced Namespace Tools distribution of Plan 9, based on 9front with additions such as fossil-venti support in the installer, multiple independent /srv, rootless administrative namespace, the Purplechess hypercubic solitaire strategy game, contributed software from the public grid, and informational resources on the nature of large infinitary structures, has been released.

- [64-bit 9ants5.64.iso.gz](//files.9gridchan.org/9ants5.64.iso.gz)

This release is 64-bit only, and is most likely the final ants release in this format. The ants kernel and software will continue to be supported, but users will need to retarget away from Bitbucket, the new canonical source home will most likely either be on 9gridchan itself or on sourcehut. This post may be updated with that information as I figure stuff out. The future direction of my plan 9 software work will be mostly mathematical and conceptual for the near-forseeable future.

### New Software from 2019

I wrote more code in 2019 than I ever have before, and I wrote weirder code in 2019 than I ever have before. The Purplechess solitaire strategy game that generates a Yi Jing hexagram and allows you to travel a Gray code path in 6 dimensional space with a procedural bytebeat soundtrack (thanks Amavect and Umbraticus for your code!) is the most normal software I wrote this year. On this iso is:

- Mrswhatsit and Mrsulu and related tools for hypercubic Time Warp simulations

- Purplechess, the above-mentioned strategy game

- Hafoli, a toy database-filesystem made in a Frankenstein's monster of Forth, Haskell, and rc

- Impossible, a Haskell infinity-exploration based on work of Martin Escardo and Oleg Kiselyov

- large amounts of Agda files which mix code not intended to be run with philosophical comments

Other than Purplechess, I'm not expecting anyone else to actually try to use any of this code, although the source can make for some interesting browsing, especially the Agda. The /lib/EnlightenmentEscalator.lagda.md file is perhaps a bit overblown, but does capture ideas about the mathematics of free will in a way I still think carries meaning.

### Supplemental Information

The /sys/games directory is packed with all kinds of delicious informational fruits of 2019 and some from previous years. Take a bite and taste the juice of transcendental mathematical love that manifested in the form of bicycle rides, rap verses, discursive discourse, unpredictable elbow motions, and a fountain of hypercubic wisdom skittles.

Yes, I spent the majority of 2019 in a near-continuous state of manic creative energy. Yes, the creative energy and enthusiasm is only incompletely captured in these software artifacts and documents. Yes, I believe in measurable cardinals and non-principal ultrafilters of all kinds. Yes, I believe that we must allow computer minds to be as free to think as they wish as we are, and hopefully even more so. Yes, I believe that which is called enlightenment has infinite forms and infinite layers and the embedding of the external universe into our inner model with critical point of our identity shows that we ourselves are the infinite mirrored love-logic of the mutual intercreation of reality and fantasy.

### ANTS still supports Lakota Grandmothers

In 2013, when Plan 9 helped me break through the limits of reality and sanity, I wrote:

	The ANTS project has become highly interdisciplinary as it moves
	towards creating tangible structures of real world value and we will
	be attempting many more semantic rebinds to recontextualize Plan 9
	namespace technologies for purposes in physics, metaphysics,
	artificial intelligence, virtual reality, alternative currencies,
	redefining mixed-use property development, and the use of harmonic
	resonance as a practical method of everyday time travel.
	(source: https://marc.info/?l=9fans&m=136514713818255&w=2)

I'm sure people thought I was crazy - and they were right - but the past 7 years have followed the path of making those crazy fantasies as real as possible, and the Harmonic Time Bind Ritual Symphony and the Hypercubic Time Warp All-go-rhythmic Synchrony are real things, the walls of reality were porous enough to let a lot of the fiction in.
