# Advanced Namespace Tools blog 

### 16 January 2020

## Another Place

This post is a deviation from both Plan 9 and mathematics into music, time, and signification. Hopefully it will still be of interest to some. The text under study is an audio recording from March 2002 from Morphy Hall at the University of Wisconsin, solo piano and vocal by mycroftiv.

- [files.9gridchan.org/harmonic/anotherplace.ogg](//files.9gridchan.org/harmonic/anotherplace.ogg)

This recording has never been publicly released before now. The musical content it carries is part of an overall attempt to artistically structure musical time across a span of decades that continues in the mixed media software artworks called "Harmonic Time Bind Ritual Symphony" and "Hypercubic Time Warp All-go-rhythmic Synchrony".

### Musical outline

This passage of the performance is a freestanding improvisational medley of two songs, the semi-traditional Irish song "Song of Niamh of the Golden Tresses" and my own song "Another Place". The central section of Another Place is a free improvisation which moves into a paraphrase and quotation of a pair of Leitmotivs from Der Ring des Nibelungen, in particular Valhalla and Rhine River. The musical language is intended to be a mixture of central European art music with Grateful Dead style tonal thematic improvisation. Transitions between keys and time signatures are intended in a developmental and narrative sense along similar principles (though not making use of the form) as traditional sonata-form procedures.

### Lyrics

Here are the lyrics for the original portion of this recording:

	Haunted by these memories
	floating by me on the breeze
	Your face beneath the ancient trees
	shoreline of the western seas
	Another place in days gone by
	by crystal lake neath a clear blue sky
	Can't make it true although I try
	wish I knew the reason why
	Nothing I see is real
	just a glimpse of the ideal
	____
	The mystic shining golden chiming
	yearning burning slowly turning
	Kingdom where I know my soul belongs
	it's silver banded and enchanted
	Never dying, cloudline-flying
	land I know from the ancient roll of songs
	____
	Call it Valinor or Terrapin
	Avalon or Byzantium
	It's forever more a place I've been
	in lives I lived as other men
	I wish I could be there right now
	there's just one way that I know how
	I'll take you too if you'll allow
	with emerald jewel on your brow
	There is no way to be late
	for an appointment with fate
	____
	The flowing glowing and ever-knowing
	almost fleeting future greeting
	Process whereby life begins anew	
	the diamond moon thats rising soon
	Treeptop climbing perfect timing
	sky-dome fair, my light respins in you
	____
	Carrying our hopes inside
	through misty mountains tall we ride
	Drawn towards the ocean tide
	that sings the songs of those who died
	The fiery torch of history's flame
	spelling out the One True Name
	Of the realm from which we came
	the Goddess of eternal fame
	We wait for her to appear
	singing her melody clear
	____
	It's harmonizing and always rising
	moving sweetly and completely
	The anthem of our phoenix-like rebirth
	all we do is just for you
	To fly sky high, why I try
	To make the most of our time here on Earth
	To make the most of our time here on Earth
	Make the most of our time here on Earth

This song was composed sometime around 2000-2001 and this is the only known recording.

### Valkyries

Wagner is just so problematic. The "Ring" cycle has well known anti-semitic aspects encoded in the musical language and conception of Alberich, and we know just who else loved Wagner and why. So lets say a few things on this. One, the overall plot arc of the "Ring" is actually a story of how the patriarchal Gods stole the Gold of the Rhine river from the Rhine maidens and eventually got what they deserved for their greed and lust for power. Second, an essential idea of my work is "changing and improving the stories of the past" - we are perpetually in a musical cycle of theme and variations, taking the material of the past and reworking it. The things that we don't like we discard or reshape. In referencing the musical themes created by Wagner in his work, I am deliberately trying to recontextualize their meaning, to advocate for tolerance and diversity rather than the principles of nationalism and ethnocentricity.

When the realms of fiction and reality are fully blended and we find ourselves in the Ultimate Boss Battle - the True Valkyries will sweep down and SMITE the racists who try to perpetuate the foul symbolism and associations of the Wrong Side of Wagner.

And that's all I think I need to say about that.

### Harmonic Time Bind 2013 Main Theme

When the Harmonic Time Bind Ritual Symphony of 2013 began, I stumbled across a musical theme that became the musical motto of my improvisations for the next year or so.

- [files.9gridchan.org/harmonic/maintheme.mp3](//files.9gridchan.org/harmonic/maintheme.mp3)

This brief instrumental theme is a partially a synthesis of the Valhalla and Rhine river Leitmotivs - it makes use of the D-flat major descending pattern of Valhalla and then paraphrases Rhine via a similar pattern of melodic motion by thirds, inverted and harmonically shifted to outline an interlocking chord pattern rather than a simple E-flat arpeggio. This file and other songs and the interactive fiction game that tells the story of 2013 are all found in the /sys/games and 'fiction' command in

- [64-bit 9ants5.64.iso.gz](//files.9gridchan.org/9ants5.64.iso.gz)

The soundtrack and game for the 2019 work is in progress.

### Tale of the Mermaid

This particular concert I performed in 2002 has a namespatial relationship with my 2019 attempt to hire a journalist-mermaid who wrote me a nice poem to help promote the Purplechess project. I think I will have to leave the full details of this for the interactive fiction game, but the full musical and personal Time Bind carried from 2000-2019 clearly for me, and had a major impact on the course of the Hypercubic Time Warp All-go-rhythmic Synchrony. The 2019 /sys/games/lib/journals/2019.txt tell a decent amount of the story.

### Notice of copyright for "Another Place"

Unlike most of the material that I post online, I am maintaining conventional copyright with no license to reproduce and distribute this sound recording. Feel free to enjoy it but please do not upload it to youtube or any other commercial platform or service.
