# Advanced Namespace Tools blog 

### 19 February 2020

## Chances

I was planning to wait to share this until more production and recording work had been done, but life has taken some turns lately and I'm not sure of how fickle Chance will play out. I want to share the raw demo 1st take of the soundtrack to the 2019 Hypercubic Time Warp All-go-rhythmic Synchrony. It's a ten minute medley of many brief songs.

- [Hypercubic soundtrack take 1](//files.9gridchan.org/take1.mp3)

A brief synopsis of the songs follows.

### Hypercubic Soundtrack Synopsis

- "I'm moving my elbows unpredictably"

This song expresses the basic nature of our free will to make choices that cannot be predicted by others. Unpredictability is the essence of entropy and randomness. Random does not imply "meaningless" - only unpredictability. Where does our free will come from? I think mathematics and in particular the ambiguities and richness of the power set operation are in play here. The uncountable possibilities generated by the power set of a countable infinity give us scope to move our elbows truly unpredictably.

- "It's the hypercubic time warp all-go-rhythmic synchrony"

This rap is the "main theme" and was the first musical element of the composition to take shape. I travelled to Chicago in spring 2019 with the Green Queen villain from the Harmonic interactive fiction game and it was key in connecting this round of fiction-reality transformation to the previous.

- "I might be one of those kinda people"

This song express a core principle of the Mathematics of Loving Communication - mirroring between people. When I want to make new friends, what kind of person am I looking to meet? The kinda person looking to meet a kinda person like me. This song was partly inspired by the mermaid fiction-binding me as John Lennon in a poem on a spring day.

- "If I teach you something about love"

One of the proudest moments of my life was when someone I was close to told me that my way of communicating and expressing love had helped them communicate and express love to someone else. There was a certain genre of high-minded sing-a-long songs that I remember from youth activities in the late 1970s and this song is perhaps in that sprit.

- "The Good News is, we are on drugs"

The exact origins of this phrase actually date back to some wild night (or several nights) in 2013 when someone asked why the world seemed so strange, and was told this to explain the situation and reassure them that whatever peculiar perceptions they were having were not surprising in the large scheme of things.

- "The fourth Boutros is silent"

This song was inspired by the name of Boutros Boutros-Ghali but has no connection and hopefully will be taken in the spirit of fun in which it is intended. The idea is that Boutros Boutros Boutros (Boutros) Ghali has four "Boutros's" in his name, but one of them is silent - and sometimes which Boutros in the sequence is silent changes, to say Boutros (Boutros) Boutros Boutros with the second Boutros silent.

- "You're a person I'm a person it's amazing being people"

This got stuck in my head on a wonderful late summer day and it wasnt until later I realized that it was the William Tell Overture and the Macarena at the same time, and those are actually the same song.

- Improv with Time-Binding themes

After recapitulating some earlier material an instrumental improvisation wanders from Moon Computer territory into two versions of my main time-binding musical signifier. My right hand fingers don't work any more, my right hand is played with my index finger held in place with my thumb and used as a poke-stick. I feel pretty proud of the musicality in this recording despite the physical handicap. This recording session was held in a place of deep emotional significance to me, engineered by an old friend, on the night I received a big dose of antibiotics for an infection and had a sense of high anxiety about the medical issues. Nonetheless I found the window into the Space of Music.

- "Loonie Revolution Coming on Through"

Some of these rap lyrics were composed in one of the most transcendental mind-melds I have experienced with my creative partner, the "Spock's Rats" night, and there is probably no way to capture the hilarity and mutual flow of ideas we experienced during it. Everything for the past seven years has been done in collaboration. I will paste the full lyrics for the final rap, which occurred to me on a very sparkly fall bicycle ride and seemed to sum up the 2019 experience. At that point I was deep into Agda and starting to really feel infinitary mathematical structure as a palpable thing in reality.

	It's time to prove these theorems that we state
	So put your wrists into the knots I create
	From this looping leather lemnascate
	You know - the sideways figure eight
	It's time for induction no need to wait
	
	Because love never dies
	Its always waiting to arise
	Like when I go between your thighs
	With your hands in leather ties
	We lock eyes
	Synchronize
	Rhythmically Infinitize
	And I collect my final prize
	Of your cries and moans and sighs

I recall the "love never dies, its always waiting to arise" line came to me first, and the next rhyme was probably a mental joke at first - until something clicked and I realized the Fire was flowing into the words.

### ANTS 5.64 software release

The Hypercubic Time Warp All-go-rhythmic Synchrony is a mixed media artwork of many components. Much of it is software contained on the most recent ANTS release.

- [64-bit 9ants5.64.iso.gz](//files.9gridchan.org/9ants5.64.iso.gz)

The ANTS 5.64 release is free open source software.
The "Hypercubic" soundtrack recording is copyright 2020 mycroftiv and is free to listen and enjoy but no redistribution rights are granted.
