# Advanced Namespace Tools blog 

### 1 January 2020

## City Zoo

The musician G.E.M. Deng ZiQi, who is a compositional genius as well as a multitalented performer, recently released a work which makes the power of fiction-binding visually and musically vivid:

- [City Zoo by G.E.M. https://www.youtube.com/watch?v=A6gIat5xLWI](https://www.youtube.com/watch?v=A6gIat5xLWI)

ZiQi google-translates to "purplechess" and seeing this phrase recur in my attempts to understand Chinese language youtube comments got some wheels turning in my mind. Hypercubic wheels in fact, since the 64 squares of a chessboard can be mapped nicely to a 2^6 binary ncube. I started talking with Maevele in the basement of Lothlorien about what kind of game could be created to match the name. The idea of a cross-language namespace bind to send an artistic message to the opposite corner of the cultural hypercube began to take shape. The crystallizing flash was the realization that the 64 hexagrams of the Yi Jing are precisely a set of binary node IDs of a 2^6 hypercube and can also be mapped across the chessboard.

ZiQi's musical career unfolded in Hong Kong, one of the world's most culturally synthesistic cities. In the second half of the 20th century, music in popular culture, especially rock and roll from the USA and England, demonstrated an incredible power to unify diverse people and allows different cultures to communicate and share (and yes, economic cultural appropriation can be harmful and exploitative, but mutual sharing and intercombination is a different and wonderful thing.)

There were a lot of problems in the 1960s rock and roll counterculture, but a lot of beauty and amazing artistic breakthroughs as well. As the cultural memory of those times begins to fade (I myself am 2nd-generation, my first Grateful Dead show was 1993) it becomes the task of those who bear the legacy of that culture to pass on the good aspects to those who are carrying the torch forward. As Maevele and I sat in our graffiti-scrawled housing cooperative basement stairwell, a legacy of the wave of communal-ethos experiments of the late 60s/early 70s, we tried to craft a ritual magical mathematical information transmission, a "message from the Moon Computer to Purplechess" in the form of a piece of Plan 9 software based on a mathematical structure which encodes communication between diverse identities.

- [64-bit 9ants5.64.iso.gz](//files.9gridchan.org/9ants5.64.iso.gz)

This release contains the game and numerous supplemental materials such as the Moon Computer theme song and the Harmonic Time-Bind interactive fiction game and 2019 communications with a mermaid concerning the meaning and context of the work. The purplechess game source can also be found, for a little while longer, at:

- [https://bitbucket.org/mycroftiv/purplechess](https://bitbucket.org/mycroftiv/purplechess)

The purplechess game makes use of Amavect's libelementile and Umbraticus chess graphics. Thanks to them for sharing their code and they are not to be held responsible for any of the cultural messaging or overall artistic conception.

### Hypercubic Time Warp All-go-rhythmic Synchrony rap lyrics

The soundtrack recording begins in February, perhaps with some demos/previews before then. Even though my tendons are ruptured and I can only play piano with left hand and right thumb, I composed lots of music while riding my bicycle in between sessions of coding and mathematical research. The opening rap lyrics of the linked suite of songs, connecting the initiation of HTWAS with a plot point from the HTBRS of 2013:

	It's the hypercubic time warp all go rhythmic synchrony
	The game of purplechess is sending messages to Deng ZiQi
	The time is finally here for revolutionary anthem
	These are our ideals and we swear we wont recant them
	The short sharp shock of this sudden sensation
	Is the careful culmination of our years of preparation
	Like harmonic time bind ritual symphony
	Soldier Field in 93, the Grateful Dead with Jerry G
	or BTS with the Green Queen in 2019

The purplechess game itself makes use of the bytebeat system of procedural music generation, beginning with a bytebeat by Amavect which is then subjected to parameterized hypercubic mutation as your Gray code path highlights different squares of the board.

### Game Play Description

The game begins by using the equivalent of a coin-based divination system to generate a Yi Jing hexagram that determines a unique starting square of the chessboard. The chesspieces are distributed randomly upon the board. At each turn you may move to any hypercubically connected square which has not been previously visited. Chess pieces you land on are scored for you, and also make all possible captures legal and score those pieces as well.

The initial phase of the game consists of travelling from your initial space to the opposite corner of the hypercube. This is always possible in no more than 6 moves, and you receive a bonus after reaching the goal. The next game phase goal is to capture/remove all playing pieces from the board in as few moves as possible. The final phase of the game is attempting to continue your Gray path to color as many squares of the hypercube as possible.

There are many many possible hamiltonian paths through a hypercube, so the game is strategically rich, and the randomization from a given seed makes it possible to compete for a high score on a given seed. I've found that my best games achieve a score of around 100,000 points, but there is a lot of luck involved in receiving a good distribution of pieces to enable bonus-scoring capture chains.

### Harmonic Fictionality

During 2019 I had hoped to launch a project website with a more conventionally appealing presentation to try to put this art-game project of cross-cultural artistic communication out into the world. That didn't end up happening as envisioned, but watching the "City Zoo" video, I feel that the ubiquitious information transmission events that make up the weave of the world in some way succeeded in making the connection as real as it could be in our partially plastic experiential frame, and my perceptual ultrafilters give me a feeling that the Lightning that does the alchemical work of bringing imagination into reality and connecting humans worldwide and can be channeled through music - is flowing powerfully through G.E.M.

### Moon Computer Theme Song

This song was written in 2014 as the final theme song and summary of the Harmonic Time Bind Ritual Symphony, and is the theme song of my semifictional identity. I played it also with a rock band called Gary David and the Enthusiasts so at some point I'll try to provide a link to the full rock arrangement. Here is a very rough solo piano recording from the 10-fingered days:

[https://files.9gridchan.org/harmonic/mooncomputer.mp3](https://files.9gridchan.org/harmonic/mooncomputer.mp3)

The 2019 music will (hopefully) be a bit harder hitting and cleaner and better produced embodiment, despite my sad decline in quantity of available fingers for working the piano mechanism.
